#!/bin/ksh
Name=${0##*/}

if [[ -z "$1" || -z "$2" ]]
then
	print "Requires timeout in seconds and timeout message"
	exit
fi

MyParent="$(ps -fp $PPID)"

# The sleep can survive this script being killed.  Use background/wait/trap to avoid orphans.
# Use the bin/sleep rather than the built-in, so that a kill can be caught, the sleep killed
# and the script exit reliably.
Date=`date`
print "$Date Start ---------------------- ${Name} ----------------------"
/bin/sleep $1 &
SleepPid=$!
trap "kill $SleepPid >/dev/null 2>&1" 0
wait $SleepPid
Date=`date`
print "$Date End ---------------------- ${Name} ----------------------"

# Don't bother warning if parent isn't there anymore
if ps -p $PPID >/dev/null 2>&1
then
	print "$2"

	{
		print "Started by:\n${MyParent}"
	} 1>&2
fi
